// AppThread.cpp : implementation file
//

#include "stdafx.h"
#include "simulator.h"
#include "AppThread.h"

#include "SrvAgent.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAppThread

IMPLEMENT_DYNCREATE(CAppThread, CWinThread)

CAppThread::CAppThread()
{
}

CAppThread::~CAppThread()
{
}

BOOL CAppThread::InitInstance()
{
	// TODO:  perform and per-thread initialization here
	return TRUE;
}

int CAppThread::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CAppThread, CWinThread)
	//{{AFX_MSG_MAP(CAppThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAppThread message handlers

SME_THREAD_CONTEXT_T g_AppThreadContext;

int CAppThread::Run() 
{
	// TODO: Add your specialized code here and/or call the base class
	HWND hWnd = AfxGetMainWnd()->m_hWnd; 

	// Set application thread ID. Simulator will post external event to the app thread by thread id.
	g_AppThreadContext.nAppThreadID = GetCurrentThreadId();

	#ifdef _DEBUG
		#ifdef _UNICODE
			AgtStartAppThread(hWnd, _T("App_UD.dll"), "AppMain", &g_AppThreadContext);
		#else
			AgtStartAppThread(hWnd, _T("App_D.dll"), "AppMain", &g_AppThreadContext);
		#endif
	#else 
		AgtStartAppThread(hWnd, _T("App.dll"), "AppMain", &g_AppThreadContext);
	#endif

	return CWinThread::Run();
}
